﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private frmIdx As Short 
	Private CallBack As Object
	Private Parent As AnchorPane
	Private f_X, f_Y, f_W, f_H As Double
	Private xMouse, yMouse As Double 
	Private isMaximized As Boolean = False
	Private lbTitle As Label 
	Private ivClose As ImageView
	Private ivMax As ImageView
	Private ivMin As ImageView
	Private pnTop As Pane
	Private pnTopLeft As Pane
	Private pnTopRight As Pane
	Private RPane As Pane
	Private ivIcon As ImageView
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(AP As AnchorPane, CBack As Object, fi As Short)
	Parent = AP
	CallBack = CBack
	frmIdx = fi
	Parent.LoadLayout("skChildN") 'Load the layout file.
	Parent.Tag = "skForm"
	lbTitle.MouseCursor = fx.Cursors.MOVE
	ivIcon.Initialize("ivIcon")
	ivIcon.Id = frmIdx
	ivIcon.Tag = "Icon"
	ivIcon.Visible = False
	Create_Events
End Sub

Private Sub Create_Events
	Dim Obj As Reflector
	Obj.Target = ivClose
	Obj.AddEventHandler2("Close_Entered", "onMouseEnteredProperty")
	Obj.AddEventHandler2("Close_Exited", "onMouseExitedProperty")
	Dim Obj As Reflector
	Obj.Target = ivMax
	Obj.AddEventHandler2("Max_Entered", "onMouseEnteredProperty")
	Obj.AddEventHandler2("Max_Exited", "onMouseExitedProperty")
	Dim Obj As Reflector
	Obj.Target = ivMin
	Obj.AddEventHandler2("Min_Entered", "onMouseEnteredProperty")
	Obj.AddEventHandler2("Min_Exited", "onMouseExitedProperty")
End Sub

Public Sub setTitle(Tt As String)
	lbTitle.Text = Tt
	ToolTipToImageView(ivIcon, Tt)
End Sub

Private Sub lbTitle_MouseDragged (EventData As MouseEvent)
	If isMaximized Then Return
   	Dim jo As JavaObject = EventData
	Dim l As Double =  jo.RunMethod("getScreenX", Null) - xMouse - Main.WindowLft
	Dim t As Double =  jo.RunMethod("getScreenY", Null) - yMouse - Main.WindowTp
	If l < 9 Then l = 9
	If l + Parent.Width > Main.windowWdt - 9 Then l = (Main.windowWdt - Parent.Width) - 9
	If t < 59 Then t = 59
	If t + Parent.Height > Main.windowHgt - 23 Then t = (Main.windowHgt - 23 - Parent.Height) 
   	Parent.Left = l
   	Parent.Top = t
End Sub

Private Sub lbTitle_MousePressed (EventData As MouseEvent)
	xMouse = EventData.X + lbTitle.Left
	yMouse = EventData.Y + lbTitle.Top
End Sub

Private Sub ivClose_MouseClicked (EventData As MouseEvent)
	CallSub2(Main, "CloseForm", frmIdx)
	Parent.RemoveNodeFromParent
End Sub

Private Sub Close_Entered_Event(e As Event)
	ivClose.SetImage(fx.LoadImage(File.DirAssets, "sk17_btCloseEnt.png"))
End Sub

Private Sub Close_Exited_Event(e As Event)
	ivClose.SetImage(fx.LoadImage(File.DirAssets, "sk17_btClose.png"))
End Sub

Private Sub ivMax_MouseClicked (EventData As MouseEvent)
	If isMaximized Then
		CallSub2(CallBack, "Form_Maximized", False) 
		CallSubDelayed(Me, "Load_Normal_Layout")
	
	Else
		CallSubDelayed(Me, "Load_Max_Layout")
	End If
	isMaximized = Not(isMaximized)
End Sub

Private Sub Load_Normal_Layout
	Parent.Left = f_X
	Parent.Top = f_Y
	Parent.PrefWidth = f_W
	Parent.PrefHeight = f_H
	lbTitle.MouseCursor = fx.Cursors.MOVE
	ivMin.Visible=True
	CallSub(Main, "ReorganizeForms")
End Sub

Private Sub Load_Max_Layout
	f_X = Parent.Left 
	f_Y = Parent.Top 
	f_W = Parent.PrefWidth 
	f_H = Parent.PrefHeight 
	lbTitle.MouseCursor = fx.Cursors.DEFAULT
	Parent.SetAnchors(pnTopRight, -1, 0, 0, -1)
	Parent.SetAnchors(pnTop, 59, 0, 101, -1)
	Parent.SetAnchors(lbTitle, 59, 0, 101, -1)
	Parent.SetAnchors(RPane, 0, 20, 0, 0)
	ivMin.Visible=False
	CallSub2(CallBack, "Form_Maximized", True) 
End Sub

Private Sub Max_Entered_Event(e As Event)
	ivMax.SetImage(fx.LoadImage(File.DirAssets, "sk17_btMaxEnt.png"))
End Sub

Private Sub Max_Exited_Event(e As Event)
	ivMax.SetImage(fx.LoadImage(File.DirAssets, "sk17_btMax.png"))
End Sub

Private Sub ivMin_MouseClicked (EventData As MouseEvent)
	ivIcon.Visible = True
	f_X = Parent.Left 
	f_Y = Parent.Top 
	f_W = Parent.PrefWidth 
	f_H = Parent.PrefHeight 
	ivIcon.SetImage(Parent.Snapshot)
	Main.AddIco(ivIcon, f_X, f_Y, f_W, f_H)
	Parent.Visible = False
End Sub

Private Sub Min_Entered_Event(e As Event)
	ivMin.SetImage(fx.LoadImage(File.DirAssets, "sk17_btMinEnt.png"))
End Sub

Private Sub Min_Exited_Event(e As Event)
	ivMin.SetImage(fx.LoadImage(File.DirAssets,  "sk17_btMin.png"))
End Sub

Private Sub ivIcon_MouseClicked (EventData As MouseEvent)
	ivIcon.RemoveNodeFromParent
	Parent.Visible = True
	front(Parent)
	ivIcon.Visible = False
	Main.RemoveIco(ivIcon.Id)
	CallSub(Main, "ReorganizeForms")
	
End Sub

Private Sub front(f As Object)
	Dim jmf As JavaObject = f
	jmf.RunMethod("toFront", Null)		
End Sub

Sub ToolTipToImageView(iv As ImageView, msg As String)
    Dim joToolTip As JavaObject
    Dim joToolTip2 As JavaObject = joToolTip.InitializeNewInstance("javafx.scene.control.Tooltip", Array(msg))
    joToolTip.RunMethod("install", Array(iv, joToolTip2))
End Sub